AddCSLuaFile( "cl_init.lua" )
AddCSLuaFile( "shared.lua" )

include('shared.lua')

ENT.Damage = 12

local schdChase = ai_schedule.New( "AIFighter Chase" )

function ENT:SpawnFunction( ply, tr )

	if ( !tr.Hit ) then return end
	
	local SpawnPos = tr.HitPos + tr.HitNormal * 20
	
	local ent = ents.Create( "npc_germanshepard_follower" )
	ent:SetPos( SpawnPos )
	ent:Spawn()
	ent:Activate()
	
	return ent
	
end

function ENT:Initialize()

	self:SetModel( "models/dogmeat.mdl"  )
	
	self:SetHullType( HULL_LARGE );
	self:SetHullSizeNormal();
	
	self:SetSolid( SOLID_BBOX ) 
	self:SetMoveType( MOVETYPE_STEP )
	
	self:CapabilitiesAdd( CAP_MOVE_GROUND | CAP_ANIMATEDFACE | CAP_TURN_HEAD | CAP_AIM_GUN | CAP_OPEN_DOORS )
	
	self:SetMaxYawSpeed( 5000 )
	
	self:SetHealth ( 1000 )
	
end

  function ENT:OnTakeDamage(dmg) 
   self:SetHealth(self:Health() - dmg:GetDamage()) 
   if self:Health() <= 0 then
   self:Remove()
   end 
  end 


function ENT:SelectSchedule()

	self:StartSchedule( schdChase ) 

end
