----------------------------
-- Spacetech's Pet Mod --
----------------------------
Player = {}
Player.Pet = {}
Player.Egg = {}
Player.Gender = {}
Player.PetAge = {}
Player.HasEgg = {}
Player.HasPet = {}
Player.Staying = {}
Player.StayPos = {}
Player.Leashed = {}
Player.PetName = {}
Player.PetTime = {}
Player.PetLeash = {}
Player.PetOName = {}
Player.PetHTime = {}
Player.LastStay = {}
Player.Following = {}
Player.LastFollow = {}
Player.LeashedPos = {}
Player.LastLeashed = {}
Player.PetAgeTimer = {}
Player.PetHungerTold1 = {}
Player.PetHungerTold2 = {}
Player.PetHungerTimer = {}
Player.LeashedBoundary = {}
RandomPetDeath = math.random(101, 109)
include("config.lua")
Version = "1.5"
if(!PetMod) then Msg("Spacetech's Pet Mod is Disabled\n") return end
-------------------------------------------------------------------
function PetThink()
    for k,ply in pairs(player.GetAll()) do
		if(Player.HasEgg[ply] && !Player.Egg[ply]:IsValid()) then
			Player.HasEgg[ply] = false
			ply:PrintMessage(HUD_PRINTTALK, "Your pet egg broke")
		elseif(Player.HasPet[ply] && !Player.Pet[ply]:IsValid()) then
			Player.HasPet[ply] = false
			ply:SetNetworkedString("HasPet", "No")
			ply:PrintMessage(HUD_PRINTTALK, "Your pet has been removed")
		elseif(Player.HasPet[ply] && Player.Pet[ply]) then
			ply:SetNetworkedString("PetHealth", Player.Pet[ply]:Health())
			ply:SetNetworkedString("PetMaxHealth", Player.Pet[ply]:GetMaxHealth())		
			--Hunger System
			Player.PetHungerTimer[ply] = CurTime()-Player.PetHTime[ply]
			if(Player.PetHungerTimer[ply] >= PetFeedTime/2 && !Player.PetHungerTold1[ply]) then
				ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." is getting hungry")
				Player.PetHungerTold1[ply] = true
			elseif(Player.PetHungerTimer[ply] >= PetFeedTime/1.5 && !Player.PetHungerTold2[ply]) then
				ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." is getting very hungry")	
				Player.PetHungerTold2[ply] = true				
			elseif(Player.PetHungerTimer[ply] >= PetFeedTime) then
				ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." has died of hunger")
				Player.Pet[ply]:Remove()
				Player.HasPet[ply] = false
				Player.PetHTime[ply] = CurTime()
				ply:SetNetworkedString("HasPet", "No")
				return
			end			
			--Age System
			Player.PetAgeTimer[ply] = CurTime()-Player.PetTime[ply]					
			if(Player.PetAgeTimer[ply] >= PetYear) then
				Player.PetAge[ply] = Player.PetAge[ply]+1
				Player.PetTime[ply] = CurTime()
				Player.PetAgeTimer[ply] = 0
				ply:SetNetworkedString("PetAge", Player.PetAge[ply])
			end
			if(Player.PetAge[ply] == 1 && Player.PetAgeTimer[ply] == 0) then
				ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." is 1year old!")			
			elseif(Player.PetAge[ply] == 10 && Player.PetAgeTimer[ply] == 0) then
				ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." is 10years old!")
			elseif(Player.PetAge[ply] == 20 && Player.PetAgeTimer[ply] == 0) then
				ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." is 20years old!")
			elseif(Player.PetAge[ply] == 30 && Player.PetAgeTimer[ply] == 0) then
				ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." is 30years old!")
			elseif(Player.PetAge[ply] == 40 && Player.PetAgeTimer[ply] == 0) then
				ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." is 40years old!")
			elseif(Player.PetAge[ply] == 50 && Player.PetAgeTimer[ply] == 0) then
				ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." is 50years old!")
			elseif(Player.PetAge[ply] == 60 && Player.PetAgeTimer[ply] == 0) then
				ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." is 60years old!")
			elseif(Player.PetAge[ply] == 70 && Player.PetAgeTimer[ply] == 0) then
				ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." is 70years old!")
			elseif(Player.PetAge[ply] == 80 && Player.PetAgeTimer[ply] == 0) then
				ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." is 80years old")
			elseif(Player.PetAge[ply] == 90 && Player.PetAgeTimer[ply] == 0) then
				ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." is 90years old")
			elseif(Player.PetAge[ply] == 100 && Player.PetAgeTimer[ply] == 0) then
				ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." is 100years old")
			elseif(Player.PetAge[ply] == RandomPetDeath && Player.PetAgeTimer[ply] == 0) then
				ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." is "..RandomPetDeath.."years old")
				ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." has died at the age of "..Player.PetAge[ply].."")
				Player.Pet[ply]:Remove()
				Player.HasPet[ply] = false
				return
			end
			
			if(Player.Staying[ply] == true && Player.Pet[ply]:GetPos() != Player.StayPos[ply]) then
				Player.LastStay[ply] = Player.LastStay[ply] or CurTime()-1
				if(Player.LastStay[ply] < CurTime()) then
					if(Player.Pet[ply]:GetPos() != Player.StayPos[ply]) then
						Player.Pet[ply]:SetLastPosition(Player.StayPos[ply])
						Player.Pet[ply]:SetSchedule(71)
						Player.LastStay[ply] = CurTime()+1
					else
						Player.LastStay[ply] = CurTime()+1
					end
				end
			end
			
			-- if(Player.Following[ply] == true) then
				-- Player.LastFollow[ply] = Player.LastFollow[ply] or CurTime()-1
				-- if(Player.LastFollow[ply] < CurTime()) then
					-- if(Player.Pet[ply]:GetPos() != ply:GetPos()) then
						-- Player.Pet[ply]:SetLastPosition(ply:GetPos())
						-- Player.Pet[ply]:SetSchedule(71)
						-- Player.LastFollow[ply] = CurTime()+2
					-- else
						-- Player.LastFollow[ply] = CurTime()+2
					-- end
				-- end
			-- end
			if(Player.Following[ply] == true) then
				Player.LastFollow[ply] = Player.LastFollow[ply] or CurTime()-1
				if(Player.LastFollow[ply] < CurTime()) then
					if(Player.Pet[ply]:GetPos() != ply:GetShootPos() - Vector(0, 72, 0)) then
						Player.Pet[ply]:SetLastPosition(ply:GetShootPos() - Vector(0, 72, 0))
						Player.Pet[ply]:SetSchedule(71)
						Player.LastFollow[ply] = CurTime()+2
					else
						Player.LastFollow[ply] = CurTime()+2
					end
				end
			end			
			
			if(Player.Leashed[ply] == true && Player.LeashedBoundary[ply] != false) then
				Player.LastLeashed[ply] = Player.LastLeashed[ply] or CurTime()-1
				local FoundIt2 = false		
				local RadiusFix = (Player.LeashedBoundary[ply]/2) * Vector(1, 1, 1)
				local BottomLeft = Player.LeashedPos[ply] - RadiusFix
				local TopRight = Player.LeashedPos[ply] + RadiusFix
				local Boundary = ents.FindInBox(BottomLeft, TopRight)
				--local Boundary = ents.FindInSphere(Player.LeashedPos[ply], Player.LeashedBoundary[ply])
				if(Player.LastLeashed[ply] < CurTime()) then
					for k,v in pairs(Boundary) do
						if(v == Player.Pet[ply]) then
							FoundIt2 = true
							return
						end
					end
					if(FoundIt2 == false) then
						Player.Pet[ply]:SetLastPosition(Player.LeashedPos[ply])
						Player.Pet[ply]:SetSchedule(71)
						Player.LastLeashed[ply] = CurTime()+2
					else
						Player.LastLeashed[ply] = CurTime()+2
					end
				end
			end
			FindNPCS(ply)
		end
	end
end

function AdoptAPet(ply, petinfo)
	if(AdminCheck(ply) == false) then ply:PrintMessage(HUD_PRINTTALK, "You cannot use that command") return end
	if(Player.HasPet[ply] || Player.HasEgg[ply]) then ply:PrintMessage(HUD_PRINTTALK, "You already have a pet") return end
	local petinfo2 = string.Replace(petinfo, ""..ChatPrefix.."adopt", "")
	local CPetN = string.Trim(string.Replace(petinfo2, "_", " "))
    local Pet =  string.Replace(petinfo2, " ", "npc_")
	
	local EggHatchTime = math.random(EggHatchTimeMin, EggHatchTimeMax)
	
	if(string.Trim(petinfo2) == "") then
		PetAdoptInfo(ply)
		return
	end
	
	local tr = TraceLine(ply)

	if(AdminCheck(ply, true) == true) then
		if(AdoptablePets[Pet] || AdoptablePetsAdmin[Pet]) then
			-- :D
		else
			ply:PrintMessage(HUD_PRINTTALK, "You can't adopt that kind of pet") 
			PetAdoptInfo(ply)
			return
		end
	elseif(!AdoptablePets[Pet]) then ply:PrintMessage(HUD_PRINTTALK, "You can't adopt that kind of pet") PetAdoptInfo(ply) return end
    if(tr.HitNonWorld) then ply:PrintMessage(HUD_PRINTTALK, "Your trace doesn't hit the world...Look at the ground around you") return end
	local ent = ents.Create("prop_physics")
	ent:SetModel("models/props_junk/watermelon01.mdl")
	ent:SetMaterial("models/shiny")
	ent:SetAngles(Angle(-0.000, -45.000, 90.000))
	ent:SetColor(255, 255, 255, 255)
	ent:SetPos(tr.HitPos + Vector(0, 0, 8.5))
	ent:Spawn()
	ent:Activate()
	ent:GetPhysicsObject():EnableMotion(false)
	if(!ent:IsInWorld()) then ply:PrintMessage(HUD_PRINTTALK, "Your "..CPetN.." egg spawned outside of the world...Re-adopt your pet") ent:Remove() return end
	
	Player.Egg[ply] = ent
	Player.HasEgg[ply] = true
	ply:PrintMessage(HUD_PRINTTALK, "Your "..CPetN.." egg has spawned. Wait until it hatches ("..EggHatchTimeMin.."-"..EggHatchTimeMax.."seconds)")
	timer.Simple(EggHatchTime, AdoptAPet2, ply, petinfo2, CPetN, Pet, ent)
end

function AdoptAPet2(ply, petinfo2, CPetN, Pet, ent)
	local Egg = ent
	Player.HasEgg[ply] = false
	if(!Egg:IsValid()) then return end

	local effectdata = EffectData()
	effectdata:SetStart(Egg:GetPos())
	effectdata:SetOrigin(Egg:GetPos())
	effectdata:SetScale(50)
	util.Effect("ThumperDust", effectdata)
	Egg:Fire("kill", "", 0)	
		
    local ent = ents.Create(Pet)
    ent:SetPos(Egg:GetPos())
    ent:AddEntityRelationship(ply, 3, 99)
    ent:Spawn()
	ent:Activate()
	ply:SetNetworkedEntity("Pet", ent)	
	if(AdoptablePetsAdmin[Pet]) then
		ent:SetMaxHealth(ASpawnHealth)
		ent:SetHealth(ASpawnHealth)
	else
		ent:SetMaxHealth(RSpawnHealth)
		ent:SetHealth(RSpawnHealth)
	end	
	ent:SetName("SPet-Pet")	
    if(!ent:IsInWorld()) then ply:PrintMessage(HUD_PRINTTALK, "Your "..CPetN.." spawned outside of the world...Re-adopt your pet") ent:Remove() return end
	
	if(math.random(1, 2) == 1) then
		Player.Gender[ply] = "Male"
	else
		Player.Gender[ply] = "Female"
	end
	Player.Pet[ply] = ent
	Player.PetAge[ply] = 0
	Player.HasPet[ply] = true
	Player.Staying[ply] = false
	Player.Leashed[ply] = false
	Player.PetAgeTimer[ply] = 0
	Player.PetLeash[ply] = false
	Player.PetOName[ply] = CPetN
	Player.Following[ply] = false
	Player.PetHungerTimer[ply] = 0
	Player.PetName[ply] = PetNameD
	Player.LeashedPos[ply] = false
	Player.PetTime[ply] = CurTime()
	Player.PetHTime[ply] = CurTime()
	Player.PetHungerTold1[ply] = false
	Player.PetHungerTold2[ply] = false
	Player.LeashedBoundary[ply] = false	
	ply:SetNetworkedString("HasPet", "Yes")
	ply:SetNetworkedString("Gender", Player.Gender[ply])
	ply:SetNetworkedString("PetAge", Player.PetAge[ply])
	ply:SetNetworkedString("PetName", Player.PetName[ply])
	--PetFollow(ply)
    for k,v in pairs(player.GetAll()) do
		if(v != ply) then
			ent:AddEntityRelationship(v, 4, 99)
		end
        v:PrintMessage(HUD_PRINTCENTER, ""..ply:Nick().." adopted a "..Player.Gender[ply].." "..Player.PetOName[ply].."")
    end
	ply:PrintMessage(HUD_PRINTTALK, "Your egg hatched a "..Player.PetOName[ply]..". Use: "..ChatPrefix.."name petname to rename your pet. Use "..ChatPrefix.."pet for other available commands")
end

function PetAdoptInfo(ply)
	ply:PrintMessage(HUD_PRINTTALK, ""..ChatPrefix.."adopt pet")
	if(string.len(AdoptablePets2) > 111) then
		local AdoptablePets21 = string.sub(AdoptablePets2, 1, 111)
		local AdoptablePets22 = string.sub(AdoptablePets2, 112)
		ply:PrintMessage(HUD_PRINTTALK, "Available Pets: "..AdoptablePets21.."")
		ply:PrintMessage(HUD_PRINTTALK, ""..AdoptablePets22.."")
	else
		ply:PrintMessage(HUD_PRINTTALK, "Available Pets: "..AdoptablePets2.."")
	end
	if(AdminCheck(ply, true) == true) then
		ply:PrintMessage(HUD_PRINTTALK, "Admin Only Pets: "..AdoptablePetsAdmin2.."")
	end
end

function PetAttack(ply, saywhat)
	if(Player.HasPet[ply] == false) then ply:PrintMessage(HUD_PRINTTALK, "You dont have a pet. Type "..ChatPrefix.."adopt for adoption options") return end
	--if(Player.Following[ply] == true) then ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." can't attack while he/she is auto following you") return end
	local attackinfo = string.Replace(saywhat, ""..ChatPrefix.."attack", "")
	local PlyNameFind = string.Trim(attackinfo)
	local FoundIt = false
	
	if(string.Trim(attackinfo) == "") then
		ply:PrintMessage(HUD_PRINTTALK, ""..ChatPrefix.."attack playername")
		return
	end
	
    for k,v in pairs(player.GetAll()) do
		if(v != ply && string.find(string.lower(v:Nick()), string.lower(PlyNameFind)) == 1) then
			Player.Pet[ply]:AddEntityRelationship(v, 1, 99)
			Player.Pet[ply]:SetLastPosition(v:GetPos())
			Player.Pet[ply]:SetSchedule(71)
			FoundIt = true
			return
		end
    end
	if(FoundIt == false) then
		ply:PrintMessage(HUD_PRINTTALK, "That player wasn't found")
	end
end

function PetFeed(ply)
	if(Player.HasPet[ply] == false) then ply:PrintMessage(HUD_PRINTTALK, "You dont have a pet. Type "..ChatPrefix.."adopt for adoption options") return end
	Player.PetHungerTimer[ply] = 0
	Player.PetHTime[ply] = CurTime()
	Player.PetHungerTold1[ply] = false
	Player.PetHungerTold2[ply] = false	
	ply:PrintMessage(HUD_PRINTTALK, "Your pet has been feed")
end

function PetFollow(ply)
	if(Player.HasPet[ply] == false) then ply:PrintMessage(HUD_PRINTTALK, "You dont have a pet. Type "..ChatPrefix.."adopt for adoption options") return
	elseif(Player.Staying[ply] == true) then ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." can't follow you while he/she is staying") return
	elseif(Player.Leashed[ply] == true) then ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." can't follow you while he/she is leashed") return end		
	if(Player.Following[ply] == true) then
		ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." will stop following you")
		Player.Following[ply] = false
	else
		ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." will follow you")
		Player.Following[ply] = true
	end
end

function PetHeal(ply)
	if(Player.HasPet[ply] == false) then ply:PrintMessage(HUD_PRINTTALK, "You dont have a pet. Type "..ChatPrefix.."adopt for adoption options") return end
	local HealDmg = math.random(HealMin, HealMax)
	local effectdata = EffectData()
	effectdata:SetStart(Player.Pet[ply]:GetPos())
	effectdata:SetOrigin(Player.Pet[ply]:GetPos())
	effectdata:SetScale(1)
	util.Effect("ThumperDust", effectdata)
	if(Player.Pet[ply]:Health() == Player.Pet[ply]:GetMaxHealth()) then
		ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." doesn't need to be healed. Current HP: "..Player.Pet[ply]:Health().."")
		return
	end
	if(Player.Pet[ply]:Health() + HealDmg >= Player.Pet[ply]:GetMaxHealth()) then
		HealDmg = Player.Pet[ply]:GetMaxHealth()-Player.Pet[ply]:Health()
	end
	Player.Pet[ply]:SetHealth(Player.Pet[ply]:Health()+HealDmg)
	if(Player.Pet[ply]:Health() > Player.Pet[ply]:GetMaxHealth()) then
		Player.Pet[ply]:SetHealth(Player.Pet[ply]:GetMaxHealth())
	end	
	ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." has been healed "..HealDmg.."damage. Current "..Player.PetOName[ply].."'s HP: "..Player.Pet[ply]:Health().."")
end

function PetKillpet(ply, saywhat)
	if(AdminCheck(ply, true) == false) then ply:PrintMessage(HUD_PRINTTALK, "You cannot use that command") return end
	local killinfo = string.Replace(saywhat, ""..ChatPrefix.."killpet", "")
	local PlyNameFind = string.Trim(killinfo)
	local FoundIt = false
	
	if(string.Trim(killinfo) == "") then
		ply:PrintMessage(HUD_PRINTTALK, ""..ChatPrefix.."killpet playername")
		return
	end

    for k,v in pairs(player.GetAll()) do
		if(v != ply && string.find(string.lower(v:Nick()), string.lower(PlyNameFind)) == 1) then
			if(Player.HasPet[v] == true) then
				local PPet = Player.Pet[v]
				local effectdata = EffectData()
				effectdata:SetStart(PPet:GetPos())
				effectdata:SetOrigin(PPet:GetPos())
				effectdata:SetScale(50)
				util.Effect("ThumperDust", effectdata)
				Player.HasPet[v] = false
				PPet:Remove()
				ply:SetNetworkedString("HasPet", "No")
				v:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[v].." has been killed by an admin")
				ply:PrintMessage(HUD_PRINTTALK, ""..v:Nick().."'s "..Player.PetOName[v].." has been killed") 
			else
				ply:PrintMessage(HUD_PRINTTALK, "That player doesn't have a pet") 
			end
			FoundIt = true
			return
		end
    end
	if(FoundIt == false) then
		ply:PrintMessage(HUD_PRINTTALK, "That player wasn't found")
	end
end

function PetLeash(ply, saywhat)
	if(Player.HasPet[ply] == false) then ply:PrintMessage(HUD_PRINTTALK, "You dont have a pet. Type "..ChatPrefix.."adopt for adoption options") return
	elseif(Player.Following[ply] == true) then ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." can't be leashed while he/she is following you") return end
	local leashinfo = string.Replace(saywhat, ""..ChatPrefix.."leash", "")
	local LeashRadius = string.Trim(leashinfo)	
	if(tonumber(LeashRadius) == nil && Player.Leashed[ply] == false) then
		ply:PrintMessage(HUD_PRINTTALK, ""..ChatPrefix.."leash radius")
		return
	end
	if(Player.Leashed[ply] == true) then
		ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." has been unleashed")
		Player.Leashed[ply] = false
		Player.LeashedPos[ply] = false
		Player.LeashedBoundary[ply] = false
		if(Player.PetLeash[ply]:IsValid()) then
			Player.PetLeash[ply]:Remove()
		end
		Player.PetLeash[ply] = false		
	elseif(LeashRadius != "") then
		ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." has been leashed in a radius of "..LeashRadius.."")
		Player.Leashed[ply] = true
		Player.LeashedPos[ply] = Player.Pet[ply]:GetPos()
		Player.LeashedBoundary[ply] = LeashRadius
		local ent = ents.Create("prop_physics")
		ent:SetModel("models/weapons/w_stunbaton.mdl")
		ent:SetAngles(Angle(90.000, -0.000, 180.000))
		ent:SetPos(Player.LeashedPos[ply] + Vector(0, 0, 8.5))
		ent:Spawn()
		ent:Activate()
		ent:GetPhysicsObject():EnableMotion(false)
		ent:SetName("SPet-PetLeash")
		Player.PetLeash[ply] = ent
		constraint.NoCollide(ent, Player.Pet[ply], 0, 0)
		--constraint.Rope(ent, Player.Pet[ply], 0, 1, ent:GetPos(), Player.Pet[ply]:GetPos(), LeashRadius, 0, 0, 0, "cable/rope", 0)
	else
		ply:PrintMessage(HUD_PRINTTALK, ""..ChatPrefix.."leash radius")
	end
end

function PetMove(ply)
	if(Player.HasPet[ply] == false) then ply:PrintMessage(HUD_PRINTTALK, "You dont have a pet. Type "..ChatPrefix.."adopt for adoption options") return end
	if(Player.Following[ply] == true) then ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." can't move while he/she is following you") return
	elseif(Player.Staying[ply] == true) then ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." can't move while he/she is staying") return end
    local tr = TraceLine(ply)	
    Player.Pet[ply]:SetLastPosition(tr.HitPos)
    Player.Pet[ply]:SetSchedule(71)
end

function PetName(ply, saywhat)
	if(Player.HasPet[ply] == false) then ply:PrintMessage(HUD_PRINTTALK, "You dont have a pet. Type "..ChatPrefix.."adopt for adoption options") return end
	local nameinfo = string.Replace(saywhat, ""..ChatPrefix.."name", "")
	local PetNameFind = string.Trim(nameinfo)
	if(string.Trim(nameinfo) == "") then
		ply:PrintMessage(HUD_PRINTTALK, ""..ChatPrefix.."name petname")
		return
	end
	Player.PetName[ply] = PetNameFind
	ply:SetNetworkedString("PetName", Player.PetName[ply])
	ply:PrintMessage(HUD_PRINTTALK, "Your pet has been renamed: "..Player.PetName[ply].."")
end

function PetPet(ply)
	ply:PrintMessage(HUD_PRINTTALK, "Pet Commands:")
	ply:PrintMessage(HUD_PRINTTALK, ChatPrefix.."spet | "..ChatPrefix.."pet | "..ChatPrefix.."adopt | "..ChatPrefix.."petinfo | "..ChatPrefix.."name | "..ChatPrefix.."follow | "..ChatPrefix.."move | "..ChatPrefix.."stay | "..ChatPrefix.."leash | "..ChatPrefix.."feed | "..ChatPrefix.."attack | "..ChatPrefix.."heal | "..ChatPrefix.."release")
	if(AdminCheck(ply, true) == true) then
		ply:PrintMessage(HUD_PRINTTALK, "Admin Only: "..ChatPrefix.."killpet")
	end
end

function PetPetInfo(ply)
	if(Player.HasPet[ply] == false) then ply:PrintMessage(HUD_PRINTTALK, "You dont have a pet. Type "..ChatPrefix.."adopt for adoption options") return end
	ply:PrintMessage(HUD_PRINTTALK, "Your pet's stats:")
	ply:PrintMessage(HUD_PRINTTALK, "Name: "..Player.PetName[ply].." - Health: "..Player.Pet[ply]:Health().." - Age: "..Player.PetAge[ply].." - Gender: "..Player.Gender[ply].." - Type: "..Player.PetOName[ply].."")
end

function PetRelease(ply)
	if(Player.HasPet[ply] == false) then ply:PrintMessage(HUD_PRINTTALK, "You dont have a pet. Type "..ChatPrefix.."adopt for adoption options") return end
	local effectdata = EffectData()
	effectdata:SetStart(Player.Pet[ply]:GetPos())
	effectdata:SetOrigin(Player.Pet[ply]:GetPos())
	effectdata:SetScale(50)
	util.Effect("ThumperDust", effectdata)
	Player.HasPet[ply] = false
	Player.Pet[ply]:Remove()
	ply:SetNetworkedString("HasPet", "No")
	ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." has been released")
end

function PetSpet(ply)
	ply:PrintMessage(HUD_PRINTTALK, "Spacetech's Pet Mod v"..Version.." by Spacetech")
end

function PetStay(ply)
	if(Player.HasPet[ply] == false) then ply:PrintMessage(HUD_PRINTTALK, "You dont have a pet. Type "..ChatPrefix.."adopt for adoption options") return
	elseif(Player.Following[ply] == true) then ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." can't stay while he/she is following you") return end
	if(Player.Staying[ply] == true) then
		ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." will no longer stay")
		Player.Staying[ply] = false
	else
		ply:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[ply].." will stay")
		Player.Staying[ply] = true
		Player.StayPos[ply] = Player.Pet[ply]:GetPos()
	end
end

function FindNPCS(ply)
	local npcs = ents.FindByClass("npc_*")
    for k,v in pairs(npcs) do
	    if(v:GetName() == "SPet-Pet") then
			Player.Pet[ply]:AddEntityRelationship(v, 4, 99)
		else
			Player.Pet[ply]:AddEntityRelationship(v, 1, 99)
		end
    end
end

function TraceLine(ply)
	local Trace = util.GetPlayerTrace(ply)	
	return util.TraceLine(Trace)
end

function AdminCheck(ply, mode)
	if(AdminOnly == true) then
		if(ply:IsSuperAdmin() || ply:IsAdmin()) then
			return true
		else
			return false
		end
	elseif(mode) then
		if(ply:IsSuperAdmin() || ply:IsAdmin()) then
			return true
		else
			return false
		end
	else
		return true
	end
end

function playerSaid(ply, saywhat)
	saywhat2 = saywhat
	saywhat = string.Replace(saywhat, '"', "")
	saywhat3 = saywhat
	saywhat = string.lower(saywhat)
	if(string.find(saywhat, ""..ChatPrefix.."petinfo") == 1) then
		PetPetInfo(ply)
		return ""
	elseif(string.find(saywhat, ""..ChatPrefix.."spet") == 1) then
		PetSpet(ply)
		return ""
	elseif(string.find(saywhat, ""..ChatPrefix.."stay") == 1) then
		PetStay(ply)
		return ""
	elseif(string.find(saywhat, ""..ChatPrefix.."pet") == 1) then
		PetPet(ply)
		return ""
	elseif(string.find(saywhat, ""..ChatPrefix.."name") == 1) then
		PetName(ply, saywhat3)
		return ""
	elseif(string.find(saywhat, ""..ChatPrefix.."feed") == 1) then
		PetFeed(ply)
		return ""
	--elseif(string.find(saywhat, "/givepet") == 1) then
		--PetGive(ply, saywhat)
	elseif(string.find(saywhat, ""..ChatPrefix.."killpet") == 1) then
		PetKillpet(ply, saywhat)
		return ""
	elseif(string.find(saywhat, ""..ChatPrefix.."move") == 1) then
		PetMove(ply)
		return ""
	elseif(string.find(saywhat, ""..ChatPrefix.."release") == 1) then
		PetRelease(ply)
		return ""
	elseif(string.find(saywhat, ""..ChatPrefix.."heal") == 1) then
		PetHeal(ply)
		return ""		
	elseif(string.find(saywhat, ""..ChatPrefix.."follow") == 1) then
		PetFollow(ply)
		return ""
	elseif(string.find(saywhat, ""..ChatPrefix.."leash") == 1) then
		PetLeash(ply, saywhat)
		return ""
	elseif(string.find(saywhat, ""..ChatPrefix.."attack") == 1) then
		if( ply:IsAdmin() ) then
                PetAttack(ply, saywhat)
		return ""
                else
                ply:PrintMessage(HUD_PRINTTALK, "[LifeCity] Attack disable...");
                return "";
                end
	elseif(string.find(saywhat, ""..ChatPrefix.."adopt") == 1) then
		AdoptAPet(ply, saywhat)
		return ""
	end
end

function PetPickup(ply, ent)
	if(ent:GetName() == "SPet-Pet") then
		if(Player.HasPet[ply] && Player.Pet[ply] == ent) then
			return true
		else
			return false
		end
    elseif(ent:GetName() == "SPet-PetLeash") then
		if(Player.PetLeash[ply] != false && Player.PetLeash[ply] == ent) then
			return true
		else
			return false
		end		
	end		
end

function PetKilled(victim, killer, weapon)
    local Players = player.GetAll()
    for k,v in pairs(Players) do
		if(Player.Pet[v] == victim) then
			v:PrintMessage(HUD_PRINTTALK, "Your "..Player.PetOName[v].." died")
			Player.HasPet[v] = false
			v:SetNetworkedString("HasPet", "No")
			return
		end
		if(Player.Pet[v] == killer) then
			local HealDmg = math.random(25, 75)
			if(Player.Pet[v]:Health() == Player.Pet[v]:GetMaxHealth()) then return end
			Player.Pet[v]:SetHealth(Player.Pet[v]:Health()+HealDmg)
			if(Player.Pet[v]:Health() > Player.Pet[v]:GetMaxHealth()) then
				Player.Pet[v]:SetHealth(Player.Pet[v]:GetMaxHealth())
			end
		end
    end
end

function PetKilledPlayer(victim, killer, weapon)
    for k,v in pairs(player.GetAll()) do
		if(Player.Pet[v] == killer) then
			Player.Pet[v]:AddEntityRelationship(victim, 4, 99)
		end
    end
end

function FirstSpawn(ply)
	Player.HasPet[ply] = false	
	if(SpawnAdvert == true) then
		ply:PrintMessage(HUD_PRINTTALK, SpawnAdvertText)
	end
    for k,v in pairs(Player.Pet) do
		if(v:IsValid()) then
			v:AddEntityRelationship(ply, 4, 99)
		end
    end
end

function Disconnect(ply)
	if(Player.HasPet[ply] && Player.Pet[ply]) then
		Player.HasPet[ply] = false
		Player.Pet[ply]:Remove()
		ply:SetNetworkedString("HasPet", "No")
	end
end

hook.Add("Think", "PetThink", PetThink)
hook.Add("OnNPCKilled", "PetKilled", PetKilled)
hook.Add("PhysgunPickup", "PetPickup", PetPickup)
hook.Add("PlayerInitialSpawn", "FirstSpawn", FirstSpawn)
hook.Add("PlayerDisconnected", "Disconnect", Disconnect)
hook.Add("PlayerSay", "playerSaid", playerSaid)
hook.Add("PlayerDeath", "PetKilledPlayer", PetKilledPlayer)
Msg("Spacetech's Petmod has loaded\n")